//
//  WTDToDoItem_v1.h
//  What ToDo
//
//  Created by Devin Coughlin on 5/21/06.
//  Copyright 2006 Objective Satisfaction. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "DCManagedObject_v1.h"

@class WTDDataModel_v1;

@interface WTDToDoItem_v1 : DCManagedObject_v1 {
	BOOL _automaticallyFillsInContextsOfSubItems;
}

// Creation

+ (WTDToDoItem_v1 *)insertedToDoItemWithPropertyListDescription:(id)propertyList inManagedObjectContext:(NSManagedObjectContext *)managedObjectContext;


+ (WTDToDoItem_v1 *)insertedRootProjectItemInManagedObjectContext:(NSManagedObjectContext *)managedObjectContext;

// Queries

+ (WTDToDoItem_v1 *)toDoItemWithUUID:(NSString *)uuid inManagedObjectContext:(NSManagedObjectContext *)managedObjectContext;

+ (NSArray *)allToDoItemsInManagedObjectContext:(NSManagedObjectContext *)managedObjectContext;

+ (NSArray *)allToDoItemsWithoutSuperItemInManagedObjectContext:(NSManagedObjectContext *)managedObjectContext;

/* Attributes */ 

- (int) indexInSuperItem;

// This should be in a WTDToDoItem_v1 controller class
- (BOOL) hasDueDate;
- (void) setHasDueDate:(BOOL)hasDueDate;


- (NSSet *) allDescendents;
- (NSSet *)allItemsInSubTree;

+ (int) calculateCompletionStatusForSetOfItems: (NSSet *) items;

- (id) propertyListRepresentation;
- (void) fillInValuesFromPropertyListDescription:(id)propertyListDescription;

- (BOOL) isAncestorOfItem:(WTDToDoItem_v1 *)item;
- (NSArray *) trunkItemsIncludingRoot: (BOOL) includeRoot;

// orderedSubItems

- (unsigned int) countOfOrderedSubItems;

- (WTDToDoItem_v1 *) objectInOrderedSubItemsAtIndex:(unsigned int)index;

- (void) insertObject:(WTDToDoItem_v1 *)toDoItem inOrderedSubItemsAtIndex:(unsigned int)index;
- (void) removeObjectFromOrderedSubItemsAtIndex:(unsigned int)index;

//This method may belong in controller layer
- (BOOL)allowsAdditionOfSubItems;


- (BOOL)automaticallyFillsInContextsOfSubItems;
- (void)setAutomaticallyFillsInContextsOfSubItems:(BOOL)automaticallyFillsInContextsOfSubItems;

@end
